﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Data;
using System.Globalization;

namespace Sample.Data {
    public class BooleanInverter : IValueConverter {

        public object Convert(object value, Type targetType, object parameter, CultureInfo culture) {
            if (targetType != typeof(bool) && targetType != typeof(Nullable<bool>)) {
                throw new ArgumentOutOfRangeException("targetType");
            }

            if (!(value is bool)) {
                throw new ArgumentOutOfRangeException("value");
            }

            return !(bool)value;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture) {
            if (targetType != typeof(bool)) {
                throw new ArgumentOutOfRangeException("targetType");
            }

            if (!(value is bool)) {
                throw new ArgumentOutOfRangeException("value");
            }

            return !(bool)value;
        }
    }
}
