﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Data;
using System.Windows.Media.Imaging;
using System.Windows.Browser;

namespace Sample.Data
{
	public class UriToBitmapImageConverter : IValueConverter
	{
		public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
		{
		    if(value is String)
		    {
		        value = new Uri("." + value as string,UriKind.RelativeOrAbsolute);
		    }
			if (!(value is Uri))
			{
				return null;
			}
			Uri uri = (Uri)value;
			//if (!uri.IsAbsoluteUri)
			//{
			//    uri = new Uri(HtmlPage.Document.DocumentUri, uri);
			//}
			return new BitmapImage(uri);
		}

		public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
		{
			if (!(value is BitmapImage))
			{
				return null;
			}
			if(targetType == typeof(Uri))
			{
			    return ((BitmapImage)value).UriSource;
			}
			if(targetType == typeof(string))
			{
                return ((BitmapImage)value).UriSource.ToString();
			}
			return null;
		}
	}
}
